/* 
 * All known MFOs to program.
 * Change this when you add a new MFO. Just add the name in the right place.
 * Make sure the variable is the same name as the classname.
 */ 
function getAllFormats() 
{
  return [hcard, hcalendar, xfolk, hreview, rellicense];
}

/*
 * Beneath are the functions I haven't really looked at and/or tried to
 * understand. They work and thats good enough for me.
 */
function isCurrentTab(tab) {
  //return tab == window.top.getBrowser().selectedTab.linkedBrowser;
  return tab == window.top.getBrowser().selectedTab.linkedBrowser;
}
function getTabForDocument(doc) {
  var tabIndex = window.top.getBrowser().getBrowserIndexForDocument(doc);
  return window.top.getBrowser().getBrowserAtIndex(tabIndex);
}

function $_(id) {
  return document.getElementById(id);
}

function showMembers(o) {
  var s = "";
  var count = 0;
  for (i in o) {
    if (count != 0) s += ",";
    s += i;
    if (count%5 == 0) s+="\n";
    count++;
  }
  alert(s);
}
function showChildren(node, prefix) {
  if (!prefix) prefix = "";
  
  var s = prefix + node.nodeName + "\n";
  prefix += "->";
  
  var nodes = node.childNodes;
  if (nodes) {
    for (var i=0; i<nodes.length; i++) {
      s += showChildren(nodes.item(i), prefix);
    }
  }
  return s;
}

function fullUrl(doc, rel) {
  if (rel) {
  	if (rel.match(/^https?:\/\//))
    	return rel;
  
  	if (rel.charAt(0) == '/') {
    	doc.location.href.match(/(https?:\/\/[^\/]+)\/.*/);
  	} else {
    	doc.location.href.match(/(.*\/)[^\/]*/);
  	}
  	return RegExp.$1 + rel;
  }
  return rel;
}

function getElementByClassName(e, tag, name) {
  var re = new RegExp("\\b"+name+"\\b");
  var l = e.getElementsByTagName(tag);
  for (var i=0; i<l.length; i++) {
    if (l[i].getAttribute("class")
        && l[i].getAttribute("class").match(re))
      return l[i];
  }
  return null;
}

function isElementOfClass(node, type, cls) {
  if (node.nodeName != "#text" && node.nodeName != "#comment") {
    if (node.getAttribute(type)) {
      var re = new RegExp("\\b" + cls + "\\b");
      return node.getAttribute(type).match(re);
    }
  }
}

/* get the child text of a node, skipping over elements nodes */
function mfo_text(e) {
  var t = null;
  if (e.tagName && e.tagName.toLowerCase() == "abbr")
    return e.getAttribute("title");
  else if (e.tagName.toLowerCase() == "img")
    return e.getAttribute("alt");
  return trim(mfo_text1(e));
}
function mfo_text1(e) {
  if (e.data && e.data.length > 0)
    return e.data;
  
  if (e.hasChildNodes) {
    var s = "";
    var children = e.childNodes;
    for (var i=0; i<children.length; i++) {
      s += mfo_text1(children.item(i));
    }
    return s;
  }
  return "";
}
/* setting a property of the format object from the text of the given
   node if node is of the specified class */
function mfo_setProps(node, foObj, clsArr) {
  for (var i=0; i<clsArr.length; i++) {
    if (isElementOfClass(node, "class", clsArr[i]))
      foObj[clsArr[i]] = mfo_text(node);
  }
}
/* setting a property of the format object from an attribute of the
   given node if node is of the specified class */
function mfo_setPropsFromAttr(node, foObj, clsArr, attr) {
  for (var i=0; i<clsArr.length; i++) {
    if (isElementOfClass(node, "class", clsArr[i]))
      foObj[clsArr[i]] = node.getAttribute(attr);
  }
}

/* set the value of a label if the value exists, or hide the label
   altogether */
function setLabelValue(win, name, val) {
  var e = getElementByClassName(win, "label", name);
  var isDescription = false;
  if (!e) {
    e = getElementByClassName(win, "description", name);
    if (e) isDescription = true;
  }
  
  if (!e) {
    alert("'" + name + "' not found");
    return;
  }
  if (val) {
    val = trim(val);
    if (isDescription)
      e.appendChild(win.ownerDocument.createTextNode(val));
    else
      e.setAttribute("value", val);
  } else {
    e.hidden = true;
  }
}
/* set the value of a button if the value exists, or hide the label
   altogether */
function setButtonValue(win, name, val, href) {
  if (!href) href = val;
  var e = getElementByClassName(win, "button", name);
  if (e) {
    if (href) {
      if (val) e.setAttribute("label", val);
      e.setAttribute("tooltiptext", href);
      e.go = __goToUrl;
      e.__href = href;
      e.setAttribute("oncommand", "this.go();");
    } else {
      e.hidden = true;
    }
  } else {
    e = getElementByClassName(win, "label", name);
    if (href) {
      if (val) e.setAttribute("value", val);
      e.setAttribute("tooltiptext", href);
      e.go = __goToUrl;
      e.__href = href;
      e.setAttribute("onclick", "this.go();");
    } else {
      e.hidden = true;
    }
  }
}
function __goToUrl() {
  var tab = window.top.getBrowser().addTab(this.__href);
  window.top.getBrowser().selectedTab = tab;
}

function chop(s, len) {
  return (s.length > len) ? s.substring(0, len-3) + "..." : s;
}
function trim(s) {
  if (!s) return s;
  if (s.match(/^\s*(.*)\s*$/)) return RegExp.$1;
  return s;
}
