/*
 * Export the node from the global mfo array to which the number points.
 */
function exportMFO(number) 
{
	var output, ios, file, fileHandler, url, foStream;

	var processor = new XSLTProcessor();
	var serializer = new XMLSerializer();

	var docXML = document.implementation.createDocument('', '', null);
	var docXSL = document.implementation.createDocument('', '', null);

	/* Load MFO xml. Clone otherwise it will be replaced in the document! */
	docXML.appendChild(__tailsMFO[number].xml.cloneNode(true));

	/* Load stylesheet, only when completly loaded continue */
	docXSL.async = false;
	docXSL.load(__tailsMFO[number].xsl);
	
	processor.importStylesheet(docXSL);

	/* transform and serialize to string */
	output = serializer.serializeToString(processor.transformToFragment(docXML, document) );

  	if( getDefault("showExportResult") ) { alert(output); }

	/* output string to file */
	file = Components.classes["@mozilla.org/file/directory_service;1"]
                     .getService(Components.interfaces.nsIProperties)
                     .get("TmpD", Components.interfaces.nsIFile);

	file.append("export."+__tailsMFO[number].ext);

	if (!file.exists()) {
		file.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0664);
	}

	var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var fileHandler = ios.getProtocolHandler("file").QueryInterface(Components.interfaces.nsIFileProtocolHandler);
	var url = fileHandler.getURLSpecFromFile(file);
	var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);

	// use 0x02 | 0x10 to open file for appending.
	foStream.init(file, 0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate
	foStream.write(output, output.length);
	foStream.close();

	/* show file contents to user, if connected to program it will open in that program
  	 * otherwise it will show in the sidebar. That sucks and needs to be corrected.
  	 */
	window.location.replace(url);
}
