var hcard = {
  className:      "vcard",
  classAttribute: "class",
  classValue:     "vcard",

  xulFile: "chrome://tailsexport/content/microformats/hcard/hcard.xul",

  mfoexport: true,

  mfogeo: function(hcard)
  { 
	if(hcard.geolat && hcard.geolon )
	{
		return true;
	}
	
	return false;
  },

  mfoextension: "vcf",
 
  xslFile: "chrome://tailsexport/content/microformats/hcard/xhtml2vcard.xsl",

  processChildNode: function(node, vcard) {
    if (isElementOfClass(node, "class", "url"))
      vcard["url"] = fullUrl(node.ownerDocument, node.getAttribute("href"));

    if (isElementOfClass(node, "class", "email")) {
      var email = node.getAttribute("href");
      if (!email) email = mfo_text(node);
      if (email.match(/mailto:([^\?]+)/))
        email = RegExp.$1;
      vcard["email"] = email;
    }

    mfo_setProps(node, vcard, ["fn", "given-name", "family-name", "title", "note", "tel", "org", "locality", "region" ]);

    if (isElementOfClass(node, "class", "logo"))
      vcard["logo"] = fullUrl(node.ownerDocument, node.getAttribute("src"));

    if (isElementOfClass(node, "class", "latitude"))
    {
	var geolat = node.getAttribute("title");
	if(!geolat) geolat = mfo_text(node);

	vcard["geolat"] = geolat;
    }

    if (isElementOfClass(node, "class", "longitude"))
    {
	var geolon = node.getAttribute("title");
	if(!geolon) geolon = mfo_text(node);

	vcard["geolon"] = geolon;
    }
  },

  add: function(formatObj) {
    for (var i=0; i<__tailsMFO.length; i++) {
      if (__tailsMFO[i].className == this.className && __tailsMFO[i].fn == formatObj.fn)
        return false;
    }
    //this.hcards[this.hcards.length] = formatObj;
    return true;
  },

  populate: function(hcard, win) {
    var e = getElementByClassName(win, "image", "hcard_logo");

    if (hcard.logo)
    {
      e.setAttribute("src", hcard.logo);
      e.setAttribute("width", "16px");
      e.setAttribute("height", "16px");
    }
    else
    {
      hcard.logo = "chrome://tailsexport/content/microformats/hcard/icon_user.gif";
    }

    var addr = undefined;

    if (hcard.locality)
      addr = hcard.locality;

    if (hcard.region)
      addr = addr ? addr+", "+hcard.region : hcard.region;

    setLabelValue(win, "hcard_addr"   , addr);
    //setLabelValue(win, "hcard_addr"   , hcard.logo);
  
    var fn = hcard.fn;
    if (hcard['given-name']) {
      fn = hcard['given-name'];
    }

    if (hcard['family-name']) {
      if (fn) fn += ' ';
      fn += hcard['family-name'];
    }

    hcard.geolabel = fn+", tel:"+hcard.tel;

    setLabelValue(win, "hcard_fn"   , fn);

    setLabelValue(win, "hcard_org"  , hcard.org);

    setLabelValue(win, "hcard_title", hcard.title);

    setLabelValue(win, "hcard_tel"  , hcard.tel);

    setButtonValue(win, "hcard_website", null, hcard.url);
    setButtonValue(win, "hcard_email", hcard.email, "mailto:"+hcard.email);
  }
};
