var hreview = {
  className: "hreview",
  classAttribute: "class",
  classValue:     "hreview",

  xulFile: "chrome://tailsexport/content/microformats/hreview/hreview.xul",

  processChildNode: function(node, hreview) {
    if (isElementOfClass(node, "class", "item")) {
      var item = new Object();
      this.processItemNode(node, item);
      buildFormatObject({ processChildNode: this.processItemNode }, node, item);
      hreview.item = item;
    }
    if (isElementOfClass(node, "class", "reviewer")) {
      var reviewer = new Object();
      this.processReviewerNode(node, reviewer);
      buildFormatObject({ processChildNode: this.processReviewerNode }, node, reviewer);
      hreview.reviewer = reviewer;
    }
    mfo_setProps(node, hreview, ["rating", "description", "summary", "type", "version"]);
    mfo_setPropsFromAttr(node, hreview, ["dtreviewed"], "title");

    if (isElementOfClass(node, "class", "url"))
      hreview.url = fullUrl(node.ownerDocument, node.getAttribute("href"));
  },

  processReviewerNode: function(node, reviewer) {
    mfo_setProps(node, reviewer, ["fn"]);
  },
  processItemNode: function(node, item) {
    mfo_setProps(node, item, ["fn"]);
  },

  add: function(formatObj) {
    return true;
  },

  populate: function(hreview, win) {
    setLabelValue(win, "hreview_item",
        hreview.item ? hreview.item.fn : undefined);
    setLabelValue(win, "hreview_reviewer",
        hreview.reviewer && hreview.reviewer.fn
            ? "by " + hreview.reviewer.fn : undefined);
    setLabelValue(win, "hreview_summary", hreview.summary);

    var e = getElementByClassName(win, "hbox", "hreview_rating");
    var stars = e.getElementsByTagName("image");
    var rating = (hreview.rating) ? hreview.rating : 0;
    if (!String(rating).match(/^\d+$/)) rating = 0;
    for (var i=rating; i<5; i++)
      stars.item(i).hidden = true;
  }
};
